import { OnChanges, SimpleChanges, ElementRef } from '@angular/core';
import { StyleRenderer, WithStyles, InputStyle } from '../minimal/renderer-style';
/**
 * @dynamic
 */
export declare class LyStyle implements WithStyles {
    readonly sRenderer: StyleRenderer;
    /** @docs-private */
    static readonly и = "LyStyle";
    static readonly $priority = -0.5;
    color: string | number | null;
    p: string | number | null;
    pf: string | number | null;
    pe: string | number | null;
    pt: string | number | null;
    pb: string | number | null;
    px: string | number | null;
    py: string | number | null;
    m: string | number | null;
    mf: string | number | null;
    me: string | number | null;
    mt: string | number | null;
    mb: string | number | null;
    mx: string | number | null;
    my: string | number | null;
    static readonly with: InputStyle<string | number | null>;
    width: string | number | null;
    maxWidth: string | number | null;
    minWidth: string | number | null;
    height: string | number | null;
    maxHeight: string | number | null;
    minHeight: string | number | null;
    set size(value: string | number | null);
    display: string | null;
    flex: string | number | null;
    flexBasis: string | number | null;
    flexDirection: string | null;
    flexGrow: string | number | null;
    flexSelf: string | null;
    flexShrink: string | number | null;
    flexWrap: string | null;
    justifyContent: string | null;
    justifyItems: string | null;
    justifySelf: string | null;
    alignContent: string | null;
    alignItems: string | null;
    order: string | number | null;
    lyStyle: string | null;
    constructor(sRenderer: StyleRenderer);
}
/**
 * @dynamic
 * Spacing
 * [p], [pf], [pe], [pt], [pb], [px], [py],
 * [m], [mf], [me], [mt], [mb], [mx], [my],
 * Sizing
 * [size],
 * [width], [maxWidth], [minWidth],
 * [height], [maxHeight], [minHeight],
 * Others
 * [lyStyle]
 */
export declare class LyStyleDeprecated extends LyStyle implements OnChanges {
    private _el;
    constructor(sRenderer: StyleRenderer, _el: ElementRef);
    ngOnChanges(changes: SimpleChanges): void;
}
